import Vue from 'vue'
import App from './App.vue'
import Router from 'vue-router'
import 'sei-ui/src/directives'
import './element-ui'
import './sei-ui'
import 'element-ui/lib/theme-chalk/index.css'
import {store, router, http, i18n} from 'sei-ui'
import 'sei-ui/src/styles/index.scss'
import {zh_CN, en} from './locale/index'
i18n.mergeLocaleMessage('zh_CN', zh_CN);
i18n.mergeLocaleMessage('en', en);
Vue.use(Router);
// Vue.prototype.$echarts = echarts
Vue.prototype.$ELEMENT = {size: 'mini'};
Vue.prototype.$routerCall = (v) => v && import('@/' + v); /* 必须保留 */
/** 系统默认对用户口令进行md5加密,如果不对用户口令进行md5加密请设置为false */
// Vue.prototype.$md5 = false;

/** 设置项目图标及名称,sysid指定使用哪个项目,不设置则在模块中有系统选择框 */
Vue.prototype.$project = {
    logo: 'assets/img/logo.png',
    sysid: 'sys'
};
Vue.config.productionTip = false;
let routeConfig = router.routeConfig
const myRouter = new Router({
    mode: 'hash',
    routes: routeConfig
});

router.setBeforeEach(myRouter);
http.setRouter(myRouter);

new Vue({
    store,
    i18n,
    router: myRouter,
    render: h => h(App)
}).$mount('#app');
