let monacoWebpackPlugin = require('monaco-editor-esm-webpack-plugin')
module.exports = {
    chainWebpack: config => {
        config.plugin('monaco-editor').use(monacoWebpackPlugin, [{languages: ['html', 'css', 'javascript', 'typescript', 'json', 'mysql']}]);
    },
    configureWebpack: (config) => {
        config.entry.app = ['babel-polyfill', './src/main.js'];
        config.module.rules.push({
            test: /\.js/,
            enforce: 'pre',
            include: /node_modules[\\\/]monaco-editor[\\\/]esm/,
            use: monacoWebpackPlugin.loader
        })
    },
    runtimeCompiler: true,
    outputDir: 'dist', /* 输出文件目录 */
    publicPath: './',
    productionSourceMap: false,
    css: {
        extract: true, /* 是否使用css分离插件 ExtractTextPlugin */
        sourceMap: false, /* 不开启 CSS source maps */
        loaderOptions: {}, /* css预设器配置项 */
        modules: false /* 启用 CSS modules for all css / pre-processor files */
    },
    transpileDependencies: ['sei-ui'],
    devServer: {
        port: 8080,
        hot: true, /* 开启热点 */
        inline: true, /* 开启页面自动刷新 */
        progress: true, /* 显示打包的进度 */
        disableHostCheck: true,
        open: true,
        watchOptions: {
            aggregateTimeout: 300
        },
        proxy: {
            '/api': {
                target: 'http://localhost:8081', /* 后台服务器地址 */
                hot: true,
                ws: false,
                changeOrigin: true
            }
        }
    }
};
